// DO NOT EDIT.
//
// Generated by the Swift generator plugin for the protocol buffer compiler.
// Source: Model.proto
//
// For information on using the generated types, please see the documentation:
//   https://github.com/apple/swift-protobuf/

// Copyright (c) 2017, Apple Inc. All rights reserved.
//
// Use of this source code is governed by a BSD-3-clause license that can be
// found in LICENSE.txt or at https://opensource.org/licenses/BSD-3-Clause

//*
// A Core ML model consists of a specification version
// and a model description,
// and can be any one of the following types:
//
// Neural Networks
//   - `NeuralNetwork`
//
// Regressors
//   - ``GLMRegressor``
//   - ``SupportVectorRegressor``
//   - ``TreeEnsembleRegressor``
//   - ``NeuralNetworkRegressor``
//   - ``BayesianProbitRegressor``
//
// Classifiers
//   - `NeuralNetworkClassifier`
//   - `TreeEnsembleClassifier`
//   - `GLMClassifier`
//   - `SupportVectorClassifier`
//   - `KNearestNeighborsClassifier`
//
// Other models
//   - `CustomModel`
//   - `TextClassifier`
//   - `WordTagger`
//   - `Gazetteer`
//   - `WordEmbedding`
//   - `VisionFeaturePrint`
//   - `LinkedModel`
//   - `SoundAnalysisPreprocessing`
//   - `ItemSimilarityRecommender`
//
// Feature Engineering
//   - `Imputer`
//   - `Scaler`
//   - `Normalizer`
//   - `OneHotEncoder`
//   - `CategoricalMapping`
//   - `FeatureVectorizer`
//   - `DictVectorizer`
//   - `ArrayFeatureExtractor`
//   - `NonMaximumSuppression`
//
// Pipelines
//   - `PipelineClassifier`
//   - `PipelineRegressor`
//   - `Pipeline`
//
// Simple Mathematical Functions
//   - `Identity`

import Foundation
import SwiftProtobuf

// If the compiler emits an error on this type, it is because this file
// was generated by a version of the `protoc` Swift plug-in that is
// incompatible with the version of SwiftProtobuf to which you are linking.
// Please ensure that your are building against the same version of the API
// that was used to generate this file.
fileprivate struct _GeneratedWithProtocGenSwiftVersion: SwiftProtobuf.ProtobufAPIVersionCheck {
  struct _2: SwiftProtobuf.ProtobufAPIVersion_2 {}
  typealias Version = _2
}

///*
/// A pipeline consisting of one or more models.
struct CoreML_Specification_Pipeline {
  // SwiftProtobuf.Message conformance is added in an extension below. See the
  // `Message` and `Message+*Additions` files in the SwiftProtobuf library for
  // methods supported on all messages.

  var models: [CoreML_Specification_Model] = []

  /// Optional names given for each model
  /// If not supplied it defaults to ["model0",..., "model"(models.size()-1)]
  /// These names can be used to disambiguate the scope / domain of a parameter
  var names: [String] = []

  var unknownFields = SwiftProtobuf.UnknownStorage()

  init() {}
}

///*
/// A classifier pipeline.
struct CoreML_Specification_PipelineClassifier {
  // SwiftProtobuf.Message conformance is added in an extension below. See the
  // `Message` and `Message+*Additions` files in the SwiftProtobuf library for
  // methods supported on all messages.

  var pipeline: CoreML_Specification_Pipeline {
    get {return _storage._pipeline ?? CoreML_Specification_Pipeline()}
    set {_uniqueStorage()._pipeline = newValue}
  }
  /// Returns true if `pipeline` has been explicitly set.
  var hasPipeline: Bool {return _storage._pipeline != nil}
  /// Clears the value of `pipeline`. Subsequent reads from it will return its default value.
  mutating func clearPipeline() {_uniqueStorage()._pipeline = nil}

  var unknownFields = SwiftProtobuf.UnknownStorage()

  init() {}

  fileprivate var _storage = _StorageClass.defaultInstance
}

///*
/// A regressor pipeline.
struct CoreML_Specification_PipelineRegressor {
  // SwiftProtobuf.Message conformance is added in an extension below. See the
  // `Message` and `Message+*Additions` files in the SwiftProtobuf library for
  // methods supported on all messages.

  var pipeline: CoreML_Specification_Pipeline {
    get {return _storage._pipeline ?? CoreML_Specification_Pipeline()}
    set {_uniqueStorage()._pipeline = newValue}
  }
  /// Returns true if `pipeline` has been explicitly set.
  var hasPipeline: Bool {return _storage._pipeline != nil}
  /// Clears the value of `pipeline`. Subsequent reads from it will return its default value.
  mutating func clearPipeline() {_uniqueStorage()._pipeline = nil}

  var unknownFields = SwiftProtobuf.UnknownStorage()

  init() {}

  fileprivate var _storage = _StorageClass.defaultInstance
}

///*
/// A feature description,
/// consisting of a name, short description, and type.
struct CoreML_Specification_FeatureDescription {
  // SwiftProtobuf.Message conformance is added in an extension below. See the
  // `Message` and `Message+*Additions` files in the SwiftProtobuf library for
  // methods supported on all messages.

  var name: String {
    get {return _storage._name}
    set {_uniqueStorage()._name = newValue}
  }

  var shortDescription: String {
    get {return _storage._shortDescription}
    set {_uniqueStorage()._shortDescription = newValue}
  }

  var type: CoreML_Specification_FeatureType {
    get {return _storage._type ?? CoreML_Specification_FeatureType()}
    set {_uniqueStorage()._type = newValue}
  }
  /// Returns true if `type` has been explicitly set.
  var hasType: Bool {return _storage._type != nil}
  /// Clears the value of `type`. Subsequent reads from it will return its default value.
  mutating func clearType() {_uniqueStorage()._type = nil}

  var unknownFields = SwiftProtobuf.UnknownStorage()

  init() {}

  fileprivate var _storage = _StorageClass.defaultInstance
}

///*
/// Model metadata,
/// consisting of a short description, a version string,
/// an author, a license, and any other user defined
/// key/value meta data.
struct CoreML_Specification_Metadata {
  // SwiftProtobuf.Message conformance is added in an extension below. See the
  // `Message` and `Message+*Additions` files in the SwiftProtobuf library for
  // methods supported on all messages.

  var shortDescription: String = String()

  var versionString: String = String()

  var author: String = String()

  var license: String = String()

  var userDefined: Dictionary<String,String> = [:]

  var unknownFields = SwiftProtobuf.UnknownStorage()

  init() {}
}

///*
/// A description of a model,
/// consisting of descriptions of its input and output features.
/// Both regressor and classifier models require the name of the
/// primary predicted output feature (``predictedFeatureName``).
/// Classifier models can specify the output feature containing
/// probabilities for the predicted classes
/// (``predictedProbabilitiesName``).
struct CoreML_Specification_ModelDescription {
  // SwiftProtobuf.Message conformance is added in an extension below. See the
  // `Message` and `Message+*Additions` files in the SwiftProtobuf library for
  // methods supported on all messages.

  var input: [CoreML_Specification_FeatureDescription] {
    get {return _storage._input}
    set {_uniqueStorage()._input = newValue}
  }

  var output: [CoreML_Specification_FeatureDescription] {
    get {return _storage._output}
    set {_uniqueStorage()._output = newValue}
  }

  var predictedFeatureName: String {
    get {return _storage._predictedFeatureName}
    set {_uniqueStorage()._predictedFeatureName = newValue}
  }

  var predictedProbabilitiesName: String {
    get {return _storage._predictedProbabilitiesName}
    set {_uniqueStorage()._predictedProbabilitiesName = newValue}
  }

  var trainingInput: [CoreML_Specification_FeatureDescription] {
    get {return _storage._trainingInput}
    set {_uniqueStorage()._trainingInput = newValue}
  }

  var metadata: CoreML_Specification_Metadata {
    get {return _storage._metadata ?? CoreML_Specification_Metadata()}
    set {_uniqueStorage()._metadata = newValue}
  }
  /// Returns true if `metadata` has been explicitly set.
  var hasMetadata: Bool {return _storage._metadata != nil}
  /// Clears the value of `metadata`. Subsequent reads from it will return its default value.
  mutating func clearMetadata() {_uniqueStorage()._metadata = nil}

  var unknownFields = SwiftProtobuf.UnknownStorage()

  init() {}

  fileprivate var _storage = _StorageClass.defaultInstance
}

///*
/// A Core ML model,
/// consisting of a specification version,
/// a model description, and a model type.
///
/// Core ML model compatibility is indicated by
/// a monotonically increasing specification version number,
/// which is incremented anytime a backward-incompatible change is made
/// (this is functionally equivalent to the MAJOR version number
/// described by `Semantic Versioning 2.0.0 <http://semver.org/>`_).
///
/// Specification Versions : OS Availability (Core ML Version)
///
/// 1 : iOS 11, macOS 10.13, tvOS 11, watchOS 4 (Core ML 1)
/// - Feedforward & Recurrent Neural Networks
/// - General Linear Models
/// - Tree Ensembles
/// - Support Vector Machines
/// - Pipelines
/// - Feature Engineering
///
/// 2 : iOS 11.2, macOS 10.13.2, tvOS 11.2, watchOS 4.2 (Core ML 1.2)
/// - Custom Layers for Neural Networks
/// - Float 16 support for Neural Network layers
///
/// 3 : iOS 12, macOS 10.14, tvOS 12, watchOS 5 (Core ML 2)
/// - Flexible shapes and image sizes
/// - Categorical sequences
/// - Core ML Vision Feature Print, Text Classifier, Word Tagger
/// - Non Max Suppression
/// - Crop and Resize Bilinear NN layers
/// - Custom Models
///
/// 4 : iOS 13, macOS 10.15, tvOS 13, watchOS 6 (Core ML 3)
/// - Updatable models
/// - Exact shape / general rank mapping for neural networks
/// - Large expansion of supported neural network layers
///   - Generalized operations
///   - Control flow
///   - Dynamic layers
///   - See NeuralNetwork.proto
/// - Nearest Neighbor Classifier
/// - Sound Analysis Prepreocessing
/// - Recommender
/// - Linked Model
/// - NLP Gazeteer
/// - NLP WordEmbedding
struct CoreML_Specification_Model {
  // SwiftProtobuf.Message conformance is added in an extension below. See the
  // `Message` and `Message+*Additions` files in the SwiftProtobuf library for
  // methods supported on all messages.

  var specificationVersion: Int32 {
    get {return _storage._specificationVersion}
    set {_uniqueStorage()._specificationVersion = newValue}
  }

  var description_p: CoreML_Specification_ModelDescription {
    get {return _storage._description_p ?? CoreML_Specification_ModelDescription()}
    set {_uniqueStorage()._description_p = newValue}
  }
  /// Returns true if `description_p` has been explicitly set.
  var hasDescription_p: Bool {return _storage._description_p != nil}
  /// Clears the value of `description_p`. Subsequent reads from it will return its default value.
  mutating func clearDescription_p() {_uniqueStorage()._description_p = nil}

  ///
  /// Following model types support on-device update:
  ///
  /// - NeuralNetworkClassifier
  /// - NeuralNetworkRegressor
  /// - NeuralNetwork
  /// - KNearestNeighborsClassifier
  var isUpdatable: Bool {
    get {return _storage._isUpdatable}
    set {_uniqueStorage()._isUpdatable = newValue}
  }

  /// start at 200 here
  /// model specific parameters:
  var type: OneOf_Type? {
    get {return _storage._type}
    set {_uniqueStorage()._type = newValue}
  }

  /// pipeline starts at 200
  var pipelineClassifier: CoreML_Specification_PipelineClassifier {
    get {
      if case .pipelineClassifier(let v)? = _storage._type {return v}
      return CoreML_Specification_PipelineClassifier()
    }
    set {_uniqueStorage()._type = .pipelineClassifier(newValue)}
  }

  var pipelineRegressor: CoreML_Specification_PipelineRegressor {
    get {
      if case .pipelineRegressor(let v)? = _storage._type {return v}
      return CoreML_Specification_PipelineRegressor()
    }
    set {_uniqueStorage()._type = .pipelineRegressor(newValue)}
  }

  var pipeline: CoreML_Specification_Pipeline {
    get {
      if case .pipeline(let v)? = _storage._type {return v}
      return CoreML_Specification_Pipeline()
    }
    set {_uniqueStorage()._type = .pipeline(newValue)}
  }

  /// regressors start at 300
  var glmRegressor: CoreML_Specification_GLMRegressor {
    get {
      if case .glmRegressor(let v)? = _storage._type {return v}
      return CoreML_Specification_GLMRegressor()
    }
    set {_uniqueStorage()._type = .glmRegressor(newValue)}
  }

  var supportVectorRegressor: CoreML_Specification_SupportVectorRegressor {
    get {
      if case .supportVectorRegressor(let v)? = _storage._type {return v}
      return CoreML_Specification_SupportVectorRegressor()
    }
    set {_uniqueStorage()._type = .supportVectorRegressor(newValue)}
  }

  var treeEnsembleRegressor: CoreML_Specification_TreeEnsembleRegressor {
    get {
      if case .treeEnsembleRegressor(let v)? = _storage._type {return v}
      return CoreML_Specification_TreeEnsembleRegressor()
    }
    set {_uniqueStorage()._type = .treeEnsembleRegressor(newValue)}
  }

  var neuralNetworkRegressor: CoreML_Specification_NeuralNetworkRegressor {
    get {
      if case .neuralNetworkRegressor(let v)? = _storage._type {return v}
      return CoreML_Specification_NeuralNetworkRegressor()
    }
    set {_uniqueStorage()._type = .neuralNetworkRegressor(newValue)}
  }

  var bayesianProbitRegressor: CoreML_Specification_BayesianProbitRegressor {
    get {
      if case .bayesianProbitRegressor(let v)? = _storage._type {return v}
      return CoreML_Specification_BayesianProbitRegressor()
    }
    set {_uniqueStorage()._type = .bayesianProbitRegressor(newValue)}
  }

  /// classifiers start at 400
  var glmClassifier: CoreML_Specification_GLMClassifier {
    get {
      if case .glmClassifier(let v)? = _storage._type {return v}
      return CoreML_Specification_GLMClassifier()
    }
    set {_uniqueStorage()._type = .glmClassifier(newValue)}
  }

  var supportVectorClassifier: CoreML_Specification_SupportVectorClassifier {
    get {
      if case .supportVectorClassifier(let v)? = _storage._type {return v}
      return CoreML_Specification_SupportVectorClassifier()
    }
    set {_uniqueStorage()._type = .supportVectorClassifier(newValue)}
  }

  var treeEnsembleClassifier: CoreML_Specification_TreeEnsembleClassifier {
    get {
      if case .treeEnsembleClassifier(let v)? = _storage._type {return v}
      return CoreML_Specification_TreeEnsembleClassifier()
    }
    set {_uniqueStorage()._type = .treeEnsembleClassifier(newValue)}
  }

  var neuralNetworkClassifier: CoreML_Specification_NeuralNetworkClassifier {
    get {
      if case .neuralNetworkClassifier(let v)? = _storage._type {return v}
      return CoreML_Specification_NeuralNetworkClassifier()
    }
    set {_uniqueStorage()._type = .neuralNetworkClassifier(newValue)}
  }

  var kNearestNeighborsClassifier: CoreML_Specification_KNearestNeighborsClassifier {
    get {
      if case .kNearestNeighborsClassifier(let v)? = _storage._type {return v}
      return CoreML_Specification_KNearestNeighborsClassifier()
    }
    set {_uniqueStorage()._type = .kNearestNeighborsClassifier(newValue)}
  }

  /// generic models start at 500
  var neuralNetwork: CoreML_Specification_NeuralNetwork {
    get {
      if case .neuralNetwork(let v)? = _storage._type {return v}
      return CoreML_Specification_NeuralNetwork()
    }
    set {_uniqueStorage()._type = .neuralNetwork(newValue)}
  }

  var itemSimilarityRecommender: CoreML_Specification_ItemSimilarityRecommender {
    get {
      if case .itemSimilarityRecommender(let v)? = _storage._type {return v}
      return CoreML_Specification_ItemSimilarityRecommender()
    }
    set {_uniqueStorage()._type = .itemSimilarityRecommender(newValue)}
  }

  /// Custom and linked models
  var customModel: CoreML_Specification_CustomModel {
    get {
      if case .customModel(let v)? = _storage._type {return v}
      return CoreML_Specification_CustomModel()
    }
    set {_uniqueStorage()._type = .customModel(newValue)}
  }

  var linkedModel: CoreML_Specification_LinkedModel {
    get {
      if case .linkedModel(let v)? = _storage._type {return v}
      return CoreML_Specification_LinkedModel()
    }
    set {_uniqueStorage()._type = .linkedModel(newValue)}
  }

  /// feature engineering starts at 600
  var oneHotEncoder: CoreML_Specification_OneHotEncoder {
    get {
      if case .oneHotEncoder(let v)? = _storage._type {return v}
      return CoreML_Specification_OneHotEncoder()
    }
    set {_uniqueStorage()._type = .oneHotEncoder(newValue)}
  }

  var imputer: CoreML_Specification_Imputer {
    get {
      if case .imputer(let v)? = _storage._type {return v}
      return CoreML_Specification_Imputer()
    }
    set {_uniqueStorage()._type = .imputer(newValue)}
  }

  var featureVectorizer: CoreML_Specification_FeatureVectorizer {
    get {
      if case .featureVectorizer(let v)? = _storage._type {return v}
      return CoreML_Specification_FeatureVectorizer()
    }
    set {_uniqueStorage()._type = .featureVectorizer(newValue)}
  }

  var dictVectorizer: CoreML_Specification_DictVectorizer {
    get {
      if case .dictVectorizer(let v)? = _storage._type {return v}
      return CoreML_Specification_DictVectorizer()
    }
    set {_uniqueStorage()._type = .dictVectorizer(newValue)}
  }

  var scaler: CoreML_Specification_Scaler {
    get {
      if case .scaler(let v)? = _storage._type {return v}
      return CoreML_Specification_Scaler()
    }
    set {_uniqueStorage()._type = .scaler(newValue)}
  }

  var categoricalMapping: CoreML_Specification_CategoricalMapping {
    get {
      if case .categoricalMapping(let v)? = _storage._type {return v}
      return CoreML_Specification_CategoricalMapping()
    }
    set {_uniqueStorage()._type = .categoricalMapping(newValue)}
  }

  var normalizer: CoreML_Specification_Normalizer {
    get {
      if case .normalizer(let v)? = _storage._type {return v}
      return CoreML_Specification_Normalizer()
    }
    set {_uniqueStorage()._type = .normalizer(newValue)}
  }

  var arrayFeatureExtractor: CoreML_Specification_ArrayFeatureExtractor {
    get {
      if case .arrayFeatureExtractor(let v)? = _storage._type {return v}
      return CoreML_Specification_ArrayFeatureExtractor()
    }
    set {_uniqueStorage()._type = .arrayFeatureExtractor(newValue)}
  }

  var nonMaximumSuppression: CoreML_Specification_NonMaximumSuppression {
    get {
      if case .nonMaximumSuppression(let v)? = _storage._type {return v}
      return CoreML_Specification_NonMaximumSuppression()
    }
    set {_uniqueStorage()._type = .nonMaximumSuppression(newValue)}
  }

  /// simple mathematical functions used for testing start at 900
  var identity: CoreML_Specification_Identity {
    get {
      if case .identity(let v)? = _storage._type {return v}
      return CoreML_Specification_Identity()
    }
    set {_uniqueStorage()._type = .identity(newValue)}
  }

  /// CoreML provided models
  var textClassifier: CoreML_Specification_CoreMLModels_TextClassifier {
    get {
      if case .textClassifier(let v)? = _storage._type {return v}
      return CoreML_Specification_CoreMLModels_TextClassifier()
    }
    set {_uniqueStorage()._type = .textClassifier(newValue)}
  }

  var wordTagger: CoreML_Specification_CoreMLModels_WordTagger {
    get {
      if case .wordTagger(let v)? = _storage._type {return v}
      return CoreML_Specification_CoreMLModels_WordTagger()
    }
    set {_uniqueStorage()._type = .wordTagger(newValue)}
  }

  var visionFeaturePrint: CoreML_Specification_CoreMLModels_VisionFeaturePrint {
    get {
      if case .visionFeaturePrint(let v)? = _storage._type {return v}
      return CoreML_Specification_CoreMLModels_VisionFeaturePrint()
    }
    set {_uniqueStorage()._type = .visionFeaturePrint(newValue)}
  }

  var soundAnalysisPreprocessing: CoreML_Specification_CoreMLModels_SoundAnalysisPreprocessing {
    get {
      if case .soundAnalysisPreprocessing(let v)? = _storage._type {return v}
      return CoreML_Specification_CoreMLModels_SoundAnalysisPreprocessing()
    }
    set {_uniqueStorage()._type = .soundAnalysisPreprocessing(newValue)}
  }

  var gazetteer: CoreML_Specification_CoreMLModels_Gazetteer {
    get {
      if case .gazetteer(let v)? = _storage._type {return v}
      return CoreML_Specification_CoreMLModels_Gazetteer()
    }
    set {_uniqueStorage()._type = .gazetteer(newValue)}
  }

  var wordEmbedding: CoreML_Specification_CoreMLModels_WordEmbedding {
    get {
      if case .wordEmbedding(let v)? = _storage._type {return v}
      return CoreML_Specification_CoreMLModels_WordEmbedding()
    }
    set {_uniqueStorage()._type = .wordEmbedding(newValue)}
  }

  var unknownFields = SwiftProtobuf.UnknownStorage()

  /// start at 200 here
  /// model specific parameters:
  enum OneOf_Type: Equatable {
    /// pipeline starts at 200
    case pipelineClassifier(CoreML_Specification_PipelineClassifier)
    case pipelineRegressor(CoreML_Specification_PipelineRegressor)
    case pipeline(CoreML_Specification_Pipeline)
    /// regressors start at 300
    case glmRegressor(CoreML_Specification_GLMRegressor)
    case supportVectorRegressor(CoreML_Specification_SupportVectorRegressor)
    case treeEnsembleRegressor(CoreML_Specification_TreeEnsembleRegressor)
    case neuralNetworkRegressor(CoreML_Specification_NeuralNetworkRegressor)
    case bayesianProbitRegressor(CoreML_Specification_BayesianProbitRegressor)
    /// classifiers start at 400
    case glmClassifier(CoreML_Specification_GLMClassifier)
    case supportVectorClassifier(CoreML_Specification_SupportVectorClassifier)
    case treeEnsembleClassifier(CoreML_Specification_TreeEnsembleClassifier)
    case neuralNetworkClassifier(CoreML_Specification_NeuralNetworkClassifier)
    case kNearestNeighborsClassifier(CoreML_Specification_KNearestNeighborsClassifier)
    /// generic models start at 500
    case neuralNetwork(CoreML_Specification_NeuralNetwork)
    case itemSimilarityRecommender(CoreML_Specification_ItemSimilarityRecommender)
    /// Custom and linked models
    case customModel(CoreML_Specification_CustomModel)
    case linkedModel(CoreML_Specification_LinkedModel)
    /// feature engineering starts at 600
    case oneHotEncoder(CoreML_Specification_OneHotEncoder)
    case imputer(CoreML_Specification_Imputer)
    case featureVectorizer(CoreML_Specification_FeatureVectorizer)
    case dictVectorizer(CoreML_Specification_DictVectorizer)
    case scaler(CoreML_Specification_Scaler)
    case categoricalMapping(CoreML_Specification_CategoricalMapping)
    case normalizer(CoreML_Specification_Normalizer)
    case arrayFeatureExtractor(CoreML_Specification_ArrayFeatureExtractor)
    case nonMaximumSuppression(CoreML_Specification_NonMaximumSuppression)
    /// simple mathematical functions used for testing start at 900
    case identity(CoreML_Specification_Identity)
    /// CoreML provided models
    case textClassifier(CoreML_Specification_CoreMLModels_TextClassifier)
    case wordTagger(CoreML_Specification_CoreMLModels_WordTagger)
    case visionFeaturePrint(CoreML_Specification_CoreMLModels_VisionFeaturePrint)
    case soundAnalysisPreprocessing(CoreML_Specification_CoreMLModels_SoundAnalysisPreprocessing)
    case gazetteer(CoreML_Specification_CoreMLModels_Gazetteer)
    case wordEmbedding(CoreML_Specification_CoreMLModels_WordEmbedding)

  #if !swift(>=4.1)
    static func ==(lhs: CoreML_Specification_Model.OneOf_Type, rhs: CoreML_Specification_Model.OneOf_Type) -> Bool {
      switch (lhs, rhs) {
      case (.pipelineClassifier(let l), .pipelineClassifier(let r)): return l == r
      case (.pipelineRegressor(let l), .pipelineRegressor(let r)): return l == r
      case (.pipeline(let l), .pipeline(let r)): return l == r
      case (.glmRegressor(let l), .glmRegressor(let r)): return l == r
      case (.supportVectorRegressor(let l), .supportVectorRegressor(let r)): return l == r
      case (.treeEnsembleRegressor(let l), .treeEnsembleRegressor(let r)): return l == r
      case (.neuralNetworkRegressor(let l), .neuralNetworkRegressor(let r)): return l == r
      case (.bayesianProbitRegressor(let l), .bayesianProbitRegressor(let r)): return l == r
      case (.glmClassifier(let l), .glmClassifier(let r)): return l == r
      case (.supportVectorClassifier(let l), .supportVectorClassifier(let r)): return l == r
      case (.treeEnsembleClassifier(let l), .treeEnsembleClassifier(let r)): return l == r
      case (.neuralNetworkClassifier(let l), .neuralNetworkClassifier(let r)): return l == r
      case (.kNearestNeighborsClassifier(let l), .kNearestNeighborsClassifier(let r)): return l == r
      case (.neuralNetwork(let l), .neuralNetwork(let r)): return l == r
      case (.itemSimilarityRecommender(let l), .itemSimilarityRecommender(let r)): return l == r
      case (.customModel(let l), .customModel(let r)): return l == r
      case (.linkedModel(let l), .linkedModel(let r)): return l == r
      case (.oneHotEncoder(let l), .oneHotEncoder(let r)): return l == r
      case (.imputer(let l), .imputer(let r)): return l == r
      case (.featureVectorizer(let l), .featureVectorizer(let r)): return l == r
      case (.dictVectorizer(let l), .dictVectorizer(let r)): return l == r
      case (.scaler(let l), .scaler(let r)): return l == r
      case (.categoricalMapping(let l), .categoricalMapping(let r)): return l == r
      case (.normalizer(let l), .normalizer(let r)): return l == r
      case (.arrayFeatureExtractor(let l), .arrayFeatureExtractor(let r)): return l == r
      case (.nonMaximumSuppression(let l), .nonMaximumSuppression(let r)): return l == r
      case (.identity(let l), .identity(let r)): return l == r
      case (.textClassifier(let l), .textClassifier(let r)): return l == r
      case (.wordTagger(let l), .wordTagger(let r)): return l == r
      case (.visionFeaturePrint(let l), .visionFeaturePrint(let r)): return l == r
      case (.soundAnalysisPreprocessing(let l), .soundAnalysisPreprocessing(let r)): return l == r
      case (.gazetteer(let l), .gazetteer(let r)): return l == r
      case (.wordEmbedding(let l), .wordEmbedding(let r)): return l == r
      default: return false
      }
    }
  #endif
  }

  init() {}

  fileprivate var _storage = _StorageClass.defaultInstance
}

// MARK: - Code below here is support for the SwiftProtobuf runtime.

fileprivate let _protobuf_package = "CoreML.Specification"

extension CoreML_Specification_Pipeline: SwiftProtobuf.Message, SwiftProtobuf._MessageImplementationBase, SwiftProtobuf._ProtoNameProviding {
  static let protoMessageName: String = _protobuf_package + ".Pipeline"
  static let _protobuf_nameMap: SwiftProtobuf._NameMap = [
    1: .same(proto: "models"),
    2: .same(proto: "names"),
  ]

  mutating func decodeMessage<D: SwiftProtobuf.Decoder>(decoder: inout D) throws {
    while let fieldNumber = try decoder.nextFieldNumber() {
      switch fieldNumber {
      case 1: try decoder.decodeRepeatedMessageField(value: &self.models)
      case 2: try decoder.decodeRepeatedStringField(value: &self.names)
      default: break
      }
    }
  }

  func traverse<V: SwiftProtobuf.Visitor>(visitor: inout V) throws {
    if !self.models.isEmpty {
      try visitor.visitRepeatedMessageField(value: self.models, fieldNumber: 1)
    }
    if !self.names.isEmpty {
      try visitor.visitRepeatedStringField(value: self.names, fieldNumber: 2)
    }
    try unknownFields.traverse(visitor: &visitor)
  }

  static func ==(lhs: CoreML_Specification_Pipeline, rhs: CoreML_Specification_Pipeline) -> Bool {
    if lhs.models != rhs.models {return false}
    if lhs.names != rhs.names {return false}
    if lhs.unknownFields != rhs.unknownFields {return false}
    return true
  }
}

extension CoreML_Specification_PipelineClassifier: SwiftProtobuf.Message, SwiftProtobuf._MessageImplementationBase, SwiftProtobuf._ProtoNameProviding {
  static let protoMessageName: String = _protobuf_package + ".PipelineClassifier"
  static let _protobuf_nameMap: SwiftProtobuf._NameMap = [
    1: .same(proto: "pipeline"),
  ]

  fileprivate class _StorageClass {
    var _pipeline: CoreML_Specification_Pipeline? = nil

    static let defaultInstance = _StorageClass()

    private init() {}

    init(copying source: _StorageClass) {
      _pipeline = source._pipeline
    }
  }

  fileprivate mutating func _uniqueStorage() -> _StorageClass {
    if !isKnownUniquelyReferenced(&_storage) {
      _storage = _StorageClass(copying: _storage)
    }
    return _storage
  }

  mutating func decodeMessage<D: SwiftProtobuf.Decoder>(decoder: inout D) throws {
    _ = _uniqueStorage()
    try withExtendedLifetime(_storage) { (_storage: _StorageClass) in
      while let fieldNumber = try decoder.nextFieldNumber() {
        switch fieldNumber {
        case 1: try decoder.decodeSingularMessageField(value: &_storage._pipeline)
        default: break
        }
      }
    }
  }

  func traverse<V: SwiftProtobuf.Visitor>(visitor: inout V) throws {
    try withExtendedLifetime(_storage) { (_storage: _StorageClass) in
      if let v = _storage._pipeline {
        try visitor.visitSingularMessageField(value: v, fieldNumber: 1)
      }
    }
    try unknownFields.traverse(visitor: &visitor)
  }

  static func ==(lhs: CoreML_Specification_PipelineClassifier, rhs: CoreML_Specification_PipelineClassifier) -> Bool {
    if lhs._storage !== rhs._storage {
      let storagesAreEqual: Bool = withExtendedLifetime((lhs._storage, rhs._storage)) { (_args: (_StorageClass, _StorageClass)) in
        let _storage = _args.0
        let rhs_storage = _args.1
        if _storage._pipeline != rhs_storage._pipeline {return false}
        return true
      }
      if !storagesAreEqual {return false}
    }
    if lhs.unknownFields != rhs.unknownFields {return false}
    return true
  }
}

extension CoreML_Specification_PipelineRegressor: SwiftProtobuf.Message, SwiftProtobuf._MessageImplementationBase, SwiftProtobuf._ProtoNameProviding {
  static let protoMessageName: String = _protobuf_package + ".PipelineRegressor"
  static let _protobuf_nameMap: SwiftProtobuf._NameMap = [
    1: .same(proto: "pipeline"),
  ]

  fileprivate class _StorageClass {
    var _pipeline: CoreML_Specification_Pipeline? = nil

    static let defaultInstance = _StorageClass()

    private init() {}

    init(copying source: _StorageClass) {
      _pipeline = source._pipeline
    }
  }

  fileprivate mutating func _uniqueStorage() -> _StorageClass {
    if !isKnownUniquelyReferenced(&_storage) {
      _storage = _StorageClass(copying: _storage)
    }
    return _storage
  }

  mutating func decodeMessage<D: SwiftProtobuf.Decoder>(decoder: inout D) throws {
    _ = _uniqueStorage()
    try withExtendedLifetime(_storage) { (_storage: _StorageClass) in
      while let fieldNumber = try decoder.nextFieldNumber() {
        switch fieldNumber {
        case 1: try decoder.decodeSingularMessageField(value: &_storage._pipeline)
        default: break
        }
      }
    }
  }

  func traverse<V: SwiftProtobuf.Visitor>(visitor: inout V) throws {
    try withExtendedLifetime(_storage) { (_storage: _StorageClass) in
      if let v = _storage._pipeline {
        try visitor.visitSingularMessageField(value: v, fieldNumber: 1)
      }
    }
    try unknownFields.traverse(visitor: &visitor)
  }

  static func ==(lhs: CoreML_Specification_PipelineRegressor, rhs: CoreML_Specification_PipelineRegressor) -> Bool {
    if lhs._storage !== rhs._storage {
      let storagesAreEqual: Bool = withExtendedLifetime((lhs._storage, rhs._storage)) { (_args: (_StorageClass, _StorageClass)) in
        let _storage = _args.0
        let rhs_storage = _args.1
        if _storage._pipeline != rhs_storage._pipeline {return false}
        return true
      }
      if !storagesAreEqual {return false}
    }
    if lhs.unknownFields != rhs.unknownFields {return false}
    return true
  }
}

extension CoreML_Specification_FeatureDescription: SwiftProtobuf.Message, SwiftProtobuf._MessageImplementationBase, SwiftProtobuf._ProtoNameProviding {
  static let protoMessageName: String = _protobuf_package + ".FeatureDescription"
  static let _protobuf_nameMap: SwiftProtobuf._NameMap = [
    1: .same(proto: "name"),
    2: .same(proto: "shortDescription"),
    3: .same(proto: "type"),
  ]

  fileprivate class _StorageClass {
    var _name: String = String()
    var _shortDescription: String = String()
    var _type: CoreML_Specification_FeatureType? = nil

    static let defaultInstance = _StorageClass()

    private init() {}

    init(copying source: _StorageClass) {
      _name = source._name
      _shortDescription = source._shortDescription
      _type = source._type
    }
  }

  fileprivate mutating func _uniqueStorage() -> _StorageClass {
    if !isKnownUniquelyReferenced(&_storage) {
      _storage = _StorageClass(copying: _storage)
    }
    return _storage
  }

  mutating func decodeMessage<D: SwiftProtobuf.Decoder>(decoder: inout D) throws {
    _ = _uniqueStorage()
    try withExtendedLifetime(_storage) { (_storage: _StorageClass) in
      while let fieldNumber = try decoder.nextFieldNumber() {
        switch fieldNumber {
        case 1: try decoder.decodeSingularStringField(value: &_storage._name)
        case 2: try decoder.decodeSingularStringField(value: &_storage._shortDescription)
        case 3: try decoder.decodeSingularMessageField(value: &_storage._type)
        default: break
        }
      }
    }
  }

  func traverse<V: SwiftProtobuf.Visitor>(visitor: inout V) throws {
    try withExtendedLifetime(_storage) { (_storage: _StorageClass) in
      if !_storage._name.isEmpty {
        try visitor.visitSingularStringField(value: _storage._name, fieldNumber: 1)
      }
      if !_storage._shortDescription.isEmpty {
        try visitor.visitSingularStringField(value: _storage._shortDescription, fieldNumber: 2)
      }
      if let v = _storage._type {
        try visitor.visitSingularMessageField(value: v, fieldNumber: 3)
      }
    }
    try unknownFields.traverse(visitor: &visitor)
  }

  static func ==(lhs: CoreML_Specification_FeatureDescription, rhs: CoreML_Specification_FeatureDescription) -> Bool {
    if lhs._storage !== rhs._storage {
      let storagesAreEqual: Bool = withExtendedLifetime((lhs._storage, rhs._storage)) { (_args: (_StorageClass, _StorageClass)) in
        let _storage = _args.0
        let rhs_storage = _args.1
        if _storage._name != rhs_storage._name {return false}
        if _storage._shortDescription != rhs_storage._shortDescription {return false}
        if _storage._type != rhs_storage._type {return false}
        return true
      }
      if !storagesAreEqual {return false}
    }
    if lhs.unknownFields != rhs.unknownFields {return false}
    return true
  }
}

extension CoreML_Specification_Metadata: SwiftProtobuf.Message, SwiftProtobuf._MessageImplementationBase, SwiftProtobuf._ProtoNameProviding {
  static let protoMessageName: String = _protobuf_package + ".Metadata"
  static let _protobuf_nameMap: SwiftProtobuf._NameMap = [
    1: .same(proto: "shortDescription"),
    2: .same(proto: "versionString"),
    3: .same(proto: "author"),
    4: .same(proto: "license"),
    100: .same(proto: "userDefined"),
  ]

  mutating func decodeMessage<D: SwiftProtobuf.Decoder>(decoder: inout D) throws {
    while let fieldNumber = try decoder.nextFieldNumber() {
      switch fieldNumber {
      case 1: try decoder.decodeSingularStringField(value: &self.shortDescription)
      case 2: try decoder.decodeSingularStringField(value: &self.versionString)
      case 3: try decoder.decodeSingularStringField(value: &self.author)
      case 4: try decoder.decodeSingularStringField(value: &self.license)
      case 100: try decoder.decodeMapField(fieldType: SwiftProtobuf._ProtobufMap<SwiftProtobuf.ProtobufString,SwiftProtobuf.ProtobufString>.self, value: &self.userDefined)
      default: break
      }
    }
  }

  func traverse<V: SwiftProtobuf.Visitor>(visitor: inout V) throws {
    if !self.shortDescription.isEmpty {
      try visitor.visitSingularStringField(value: self.shortDescription, fieldNumber: 1)
    }
    if !self.versionString.isEmpty {
      try visitor.visitSingularStringField(value: self.versionString, fieldNumber: 2)
    }
    if !self.author.isEmpty {
      try visitor.visitSingularStringField(value: self.author, fieldNumber: 3)
    }
    if !self.license.isEmpty {
      try visitor.visitSingularStringField(value: self.license, fieldNumber: 4)
    }
    if !self.userDefined.isEmpty {
      try visitor.visitMapField(fieldType: SwiftProtobuf._ProtobufMap<SwiftProtobuf.ProtobufString,SwiftProtobuf.ProtobufString>.self, value: self.userDefined, fieldNumber: 100)
    }
    try unknownFields.traverse(visitor: &visitor)
  }

  static func ==(lhs: CoreML_Specification_Metadata, rhs: CoreML_Specification_Metadata) -> Bool {
    if lhs.shortDescription != rhs.shortDescription {return false}
    if lhs.versionString != rhs.versionString {return false}
    if lhs.author != rhs.author {return false}
    if lhs.license != rhs.license {return false}
    if lhs.userDefined != rhs.userDefined {return false}
    if lhs.unknownFields != rhs.unknownFields {return false}
    return true
  }
}

extension CoreML_Specification_ModelDescription: SwiftProtobuf.Message, SwiftProtobuf._MessageImplementationBase, SwiftProtobuf._ProtoNameProviding {
  static let protoMessageName: String = _protobuf_package + ".ModelDescription"
  static let _protobuf_nameMap: SwiftProtobuf._NameMap = [
    1: .same(proto: "input"),
    10: .same(proto: "output"),
    11: .same(proto: "predictedFeatureName"),
    12: .same(proto: "predictedProbabilitiesName"),
    50: .same(proto: "trainingInput"),
    100: .same(proto: "metadata"),
  ]

  fileprivate class _StorageClass {
    var _input: [CoreML_Specification_FeatureDescription] = []
    var _output: [CoreML_Specification_FeatureDescription] = []
    var _predictedFeatureName: String = String()
    var _predictedProbabilitiesName: String = String()
    var _trainingInput: [CoreML_Specification_FeatureDescription] = []
    var _metadata: CoreML_Specification_Metadata? = nil

    static let defaultInstance = _StorageClass()

    private init() {}

    init(copying source: _StorageClass) {
      _input = source._input
      _output = source._output
      _predictedFeatureName = source._predictedFeatureName
      _predictedProbabilitiesName = source._predictedProbabilitiesName
      _trainingInput = source._trainingInput
      _metadata = source._metadata
    }
  }

  fileprivate mutating func _uniqueStorage() -> _StorageClass {
    if !isKnownUniquelyReferenced(&_storage) {
      _storage = _StorageClass(copying: _storage)
    }
    return _storage
  }

  mutating func decodeMessage<D: SwiftProtobuf.Decoder>(decoder: inout D) throws {
    _ = _uniqueStorage()
    try withExtendedLifetime(_storage) { (_storage: _StorageClass) in
      while let fieldNumber = try decoder.nextFieldNumber() {
        switch fieldNumber {
        case 1: try decoder.decodeRepeatedMessageField(value: &_storage._input)
        case 10: try decoder.decodeRepeatedMessageField(value: &_storage._output)
        case 11: try decoder.decodeSingularStringField(value: &_storage._predictedFeatureName)
        case 12: try decoder.decodeSingularStringField(value: &_storage._predictedProbabilitiesName)
        case 50: try decoder.decodeRepeatedMessageField(value: &_storage._trainingInput)
        case 100: try decoder.decodeSingularMessageField(value: &_storage._metadata)
        default: break
        }
      }
    }
  }

  func traverse<V: SwiftProtobuf.Visitor>(visitor: inout V) throws {
    try withExtendedLifetime(_storage) { (_storage: _StorageClass) in
      if !_storage._input.isEmpty {
        try visitor.visitRepeatedMessageField(value: _storage._input, fieldNumber: 1)
      }
      if !_storage._output.isEmpty {
        try visitor.visitRepeatedMessageField(value: _storage._output, fieldNumber: 10)
      }
      if !_storage._predictedFeatureName.isEmpty {
        try visitor.visitSingularStringField(value: _storage._predictedFeatureName, fieldNumber: 11)
      }
      if !_storage._predictedProbabilitiesName.isEmpty {
        try visitor.visitSingularStringField(value: _storage._predictedProbabilitiesName, fieldNumber: 12)
      }
      if !_storage._trainingInput.isEmpty {
        try visitor.visitRepeatedMessageField(value: _storage._trainingInput, fieldNumber: 50)
      }
      if let v = _storage._metadata {
        try visitor.visitSingularMessageField(value: v, fieldNumber: 100)
      }
    }
    try unknownFields.traverse(visitor: &visitor)
  }

  static func ==(lhs: CoreML_Specification_ModelDescription, rhs: CoreML_Specification_ModelDescription) -> Bool {
    if lhs._storage !== rhs._storage {
      let storagesAreEqual: Bool = withExtendedLifetime((lhs._storage, rhs._storage)) { (_args: (_StorageClass, _StorageClass)) in
        let _storage = _args.0
        let rhs_storage = _args.1
        if _storage._input != rhs_storage._input {return false}
        if _storage._output != rhs_storage._output {return false}
        if _storage._predictedFeatureName != rhs_storage._predictedFeatureName {return false}
        if _storage._predictedProbabilitiesName != rhs_storage._predictedProbabilitiesName {return false}
        if _storage._trainingInput != rhs_storage._trainingInput {return false}
        if _storage._metadata != rhs_storage._metadata {return false}
        return true
      }
      if !storagesAreEqual {return false}
    }
    if lhs.unknownFields != rhs.unknownFields {return false}
    return true
  }
}

extension CoreML_Specification_Model: SwiftProtobuf.Message, SwiftProtobuf._MessageImplementationBase, SwiftProtobuf._ProtoNameProviding {
  static let protoMessageName: String = _protobuf_package + ".Model"
  static let _protobuf_nameMap: SwiftProtobuf._NameMap = [
    1: .same(proto: "specificationVersion"),
    2: .same(proto: "description"),
    10: .same(proto: "isUpdatable"),
    200: .same(proto: "pipelineClassifier"),
    201: .same(proto: "pipelineRegressor"),
    202: .same(proto: "pipeline"),
    300: .same(proto: "glmRegressor"),
    301: .same(proto: "supportVectorRegressor"),
    302: .same(proto: "treeEnsembleRegressor"),
    303: .same(proto: "neuralNetworkRegressor"),
    304: .same(proto: "bayesianProbitRegressor"),
    400: .same(proto: "glmClassifier"),
    401: .same(proto: "supportVectorClassifier"),
    402: .same(proto: "treeEnsembleClassifier"),
    403: .same(proto: "neuralNetworkClassifier"),
    404: .same(proto: "kNearestNeighborsClassifier"),
    500: .same(proto: "neuralNetwork"),
    501: .same(proto: "itemSimilarityRecommender"),
    555: .same(proto: "customModel"),
    556: .same(proto: "linkedModel"),
    600: .same(proto: "oneHotEncoder"),
    601: .same(proto: "imputer"),
    602: .same(proto: "featureVectorizer"),
    603: .same(proto: "dictVectorizer"),
    604: .same(proto: "scaler"),
    606: .same(proto: "categoricalMapping"),
    607: .same(proto: "normalizer"),
    609: .same(proto: "arrayFeatureExtractor"),
    610: .same(proto: "nonMaximumSuppression"),
    900: .same(proto: "identity"),
    2000: .same(proto: "textClassifier"),
    2001: .same(proto: "wordTagger"),
    2002: .same(proto: "visionFeaturePrint"),
    2003: .same(proto: "soundAnalysisPreprocessing"),
    2004: .same(proto: "gazetteer"),
    2005: .same(proto: "wordEmbedding"),
  ]

  fileprivate class _StorageClass {
    var _specificationVersion: Int32 = 0
    var _description_p: CoreML_Specification_ModelDescription? = nil
    var _isUpdatable: Bool = false
    var _type: CoreML_Specification_Model.OneOf_Type?

    static let defaultInstance = _StorageClass()

    private init() {}

    init(copying source: _StorageClass) {
      _specificationVersion = source._specificationVersion
      _description_p = source._description_p
      _isUpdatable = source._isUpdatable
      _type = source._type
    }
  }

  fileprivate mutating func _uniqueStorage() -> _StorageClass {
    if !isKnownUniquelyReferenced(&_storage) {
      _storage = _StorageClass(copying: _storage)
    }
    return _storage
  }

  mutating func decodeMessage<D: SwiftProtobuf.Decoder>(decoder: inout D) throws {
    _ = _uniqueStorage()
    try withExtendedLifetime(_storage) { (_storage: _StorageClass) in
      while let fieldNumber = try decoder.nextFieldNumber() {
        switch fieldNumber {
        case 1: try decoder.decodeSingularInt32Field(value: &_storage._specificationVersion)
        case 2: try decoder.decodeSingularMessageField(value: &_storage._description_p)
        case 10: try decoder.decodeSingularBoolField(value: &_storage._isUpdatable)
        case 200:
          var v: CoreML_Specification_PipelineClassifier?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .pipelineClassifier(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .pipelineClassifier(v)}
        case 201:
          var v: CoreML_Specification_PipelineRegressor?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .pipelineRegressor(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .pipelineRegressor(v)}
        case 202:
          var v: CoreML_Specification_Pipeline?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .pipeline(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .pipeline(v)}
        case 300:
          var v: CoreML_Specification_GLMRegressor?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .glmRegressor(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .glmRegressor(v)}
        case 301:
          var v: CoreML_Specification_SupportVectorRegressor?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .supportVectorRegressor(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .supportVectorRegressor(v)}
        case 302:
          var v: CoreML_Specification_TreeEnsembleRegressor?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .treeEnsembleRegressor(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .treeEnsembleRegressor(v)}
        case 303:
          var v: CoreML_Specification_NeuralNetworkRegressor?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .neuralNetworkRegressor(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .neuralNetworkRegressor(v)}
        case 304:
          var v: CoreML_Specification_BayesianProbitRegressor?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .bayesianProbitRegressor(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .bayesianProbitRegressor(v)}
        case 400:
          var v: CoreML_Specification_GLMClassifier?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .glmClassifier(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .glmClassifier(v)}
        case 401:
          var v: CoreML_Specification_SupportVectorClassifier?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .supportVectorClassifier(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .supportVectorClassifier(v)}
        case 402:
          var v: CoreML_Specification_TreeEnsembleClassifier?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .treeEnsembleClassifier(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .treeEnsembleClassifier(v)}
        case 403:
          var v: CoreML_Specification_NeuralNetworkClassifier?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .neuralNetworkClassifier(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .neuralNetworkClassifier(v)}
        case 404:
          var v: CoreML_Specification_KNearestNeighborsClassifier?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .kNearestNeighborsClassifier(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .kNearestNeighborsClassifier(v)}
        case 500:
          var v: CoreML_Specification_NeuralNetwork?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .neuralNetwork(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .neuralNetwork(v)}
        case 501:
          var v: CoreML_Specification_ItemSimilarityRecommender?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .itemSimilarityRecommender(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .itemSimilarityRecommender(v)}
        case 555:
          var v: CoreML_Specification_CustomModel?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .customModel(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .customModel(v)}
        case 556:
          var v: CoreML_Specification_LinkedModel?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .linkedModel(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .linkedModel(v)}
        case 600:
          var v: CoreML_Specification_OneHotEncoder?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .oneHotEncoder(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .oneHotEncoder(v)}
        case 601:
          var v: CoreML_Specification_Imputer?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .imputer(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .imputer(v)}
        case 602:
          var v: CoreML_Specification_FeatureVectorizer?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .featureVectorizer(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .featureVectorizer(v)}
        case 603:
          var v: CoreML_Specification_DictVectorizer?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .dictVectorizer(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .dictVectorizer(v)}
        case 604:
          var v: CoreML_Specification_Scaler?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .scaler(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .scaler(v)}
        case 606:
          var v: CoreML_Specification_CategoricalMapping?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .categoricalMapping(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .categoricalMapping(v)}
        case 607:
          var v: CoreML_Specification_Normalizer?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .normalizer(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .normalizer(v)}
        case 609:
          var v: CoreML_Specification_ArrayFeatureExtractor?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .arrayFeatureExtractor(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .arrayFeatureExtractor(v)}
        case 610:
          var v: CoreML_Specification_NonMaximumSuppression?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .nonMaximumSuppression(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .nonMaximumSuppression(v)}
        case 900:
          var v: CoreML_Specification_Identity?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .identity(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .identity(v)}
        case 2000:
          var v: CoreML_Specification_CoreMLModels_TextClassifier?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .textClassifier(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .textClassifier(v)}
        case 2001:
          var v: CoreML_Specification_CoreMLModels_WordTagger?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .wordTagger(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .wordTagger(v)}
        case 2002:
          var v: CoreML_Specification_CoreMLModels_VisionFeaturePrint?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .visionFeaturePrint(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .visionFeaturePrint(v)}
        case 2003:
          var v: CoreML_Specification_CoreMLModels_SoundAnalysisPreprocessing?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .soundAnalysisPreprocessing(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .soundAnalysisPreprocessing(v)}
        case 2004:
          var v: CoreML_Specification_CoreMLModels_Gazetteer?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .gazetteer(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .gazetteer(v)}
        case 2005:
          var v: CoreML_Specification_CoreMLModels_WordEmbedding?
          if let current = _storage._type {
            try decoder.handleConflictingOneOf()
            if case .wordEmbedding(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._type = .wordEmbedding(v)}
        default: break
        }
      }
    }
  }

  func traverse<V: SwiftProtobuf.Visitor>(visitor: inout V) throws {
    try withExtendedLifetime(_storage) { (_storage: _StorageClass) in
      if _storage._specificationVersion != 0 {
        try visitor.visitSingularInt32Field(value: _storage._specificationVersion, fieldNumber: 1)
      }
      if let v = _storage._description_p {
        try visitor.visitSingularMessageField(value: v, fieldNumber: 2)
      }
      if _storage._isUpdatable != false {
        try visitor.visitSingularBoolField(value: _storage._isUpdatable, fieldNumber: 10)
      }
      switch _storage._type {
      case .pipelineClassifier(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 200)
      case .pipelineRegressor(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 201)
      case .pipeline(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 202)
      case .glmRegressor(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 300)
      case .supportVectorRegressor(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 301)
      case .treeEnsembleRegressor(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 302)
      case .neuralNetworkRegressor(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 303)
      case .bayesianProbitRegressor(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 304)
      case .glmClassifier(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 400)
      case .supportVectorClassifier(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 401)
      case .treeEnsembleClassifier(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 402)
      case .neuralNetworkClassifier(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 403)
      case .kNearestNeighborsClassifier(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 404)
      case .neuralNetwork(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 500)
      case .itemSimilarityRecommender(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 501)
      case .customModel(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 555)
      case .linkedModel(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 556)
      case .oneHotEncoder(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 600)
      case .imputer(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 601)
      case .featureVectorizer(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 602)
      case .dictVectorizer(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 603)
      case .scaler(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 604)
      case .categoricalMapping(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 606)
      case .normalizer(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 607)
      case .arrayFeatureExtractor(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 609)
      case .nonMaximumSuppression(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 610)
      case .identity(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 900)
      case .textClassifier(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 2000)
      case .wordTagger(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 2001)
      case .visionFeaturePrint(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 2002)
      case .soundAnalysisPreprocessing(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 2003)
      case .gazetteer(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 2004)
      case .wordEmbedding(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 2005)
      case nil: break
      }
    }
    try unknownFields.traverse(visitor: &visitor)
  }

  static func ==(lhs: CoreML_Specification_Model, rhs: CoreML_Specification_Model) -> Bool {
    if lhs._storage !== rhs._storage {
      let storagesAreEqual: Bool = withExtendedLifetime((lhs._storage, rhs._storage)) { (_args: (_StorageClass, _StorageClass)) in
        let _storage = _args.0
        let rhs_storage = _args.1
        if _storage._specificationVersion != rhs_storage._specificationVersion {return false}
        if _storage._description_p != rhs_storage._description_p {return false}
        if _storage._isUpdatable != rhs_storage._isUpdatable {return false}
        if _storage._type != rhs_storage._type {return false}
        return true
      }
      if !storagesAreEqual {return false}
    }
    if lhs.unknownFields != rhs.unknownFields {return false}
    return true
  }
}
